
source('https://waxworksmath.com/Authors/G_M/Luenberger/Investment_Science/Code/Chapter12/utils.R')

S0 = 50
r = 0.05
deltat = 1/20
R = exp(r*deltat)
u = 1.01
d = 1/u ## approximately equal 1-0.01=0.99
q = (R - d)/(u - d)
print(c(u, d, R, q))

nsteps = 20
SSpot = make_spot_table(S0, u, d, nsteps)
print('Final prices:')
print(SSpot[, nsteps+1])

C = evaluate_call_option(SSpot, K=53, q, R, type='European')
print('Option value:')
print(round(C[1, 1], 1))




