S0 = 92.0
r = 0.018
T = 0.5 ## years
K = 98
sigma = 0.2

d1 = (log(S0/K) + (r + 0.5 * sigma^2) * T)/(sigma * sqrt(T))
d2 = d1 - sigma*sqrt(T)
C = pnorm(d1)*S0 - pnorm(d2)*K*exp(-r*T)

## Part (a):
##
print(sprintf('d1= %f; d2= %f; Call value= %f', d1, d2, C))

## Part (b):
##
iv = max(S0-K, 0) ## intrinsic value
aiv = max(S0-K*exp(-r*T), 0) ## adjusted intrinsic value
tv = C - iv ## time value
print(sprintf('intrinsic= %f; adjusted intrinsic= %f; time= %f', iv, aiv, tv))

## Part (c):
##
P = C + exp(-r*T)*K - S0
print(sprintf('Put value= %f', P))

## Part (d):
##
T = 0.25 
S0 = 95
d1 = (log(S0/K) + (r + 0.5 * sigma^2) * T)/(sigma * sqrt(T))
d2 = d1 - sigma*sqrt(T)
C = pnorm(d1)*S0 - pnorm(d2)*K*exp(-r*T)
print(sprintf('d1= %f; d2= %f; Call value= %f', d1, d2, C))
