
source('https://waxworksmath.com/Authors/G_M/Luenberger/Investment_Science/Code/Chapter12/utils.R')

S0 = 100
r = 0.03
deltat = 1.0
R = exp(r*deltat)
u = 1.0 + 0.2
d = 1/u ## force the tree to be recombining assume this is "approximately" equal 1-0.2=0.80
q = (R - d)/(u - d)
print(c(u, d, R, q))

nsteps = 2
SSpot = make_spot_table(S0, u, d, nsteps)
print(SSpot)

K=110

P = evaluate_put_option(SSpot, K, q, R, type='European')
print('European put value:')
print(round(P, 1))

print('Puts intrinsic value:')
print(pmax(K-SSpot, 0))

P = evaluate_put_option(SSpot, K, q, R, type='American')
print('American put value:')
print(round(P, 1))




